// http://seta43.blogspot.com/
// http://seta43.duckdns.org/informa.html


package com.example.tester;

import java.util.ArrayList;
import java.util.Set;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.util.UUID;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.DialogInterface;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;


@SuppressLint("HandlerLeak") public class MainActivity extends Activity 
{
	
	private EditText Wentrada, Wsalida;
	private BluetoothAdapter Miblue;
	
	private Set<BluetoothDevice>pairedDevices;
	
	private BluetoothSocket btSocket = null;
	private OutputStream outStream = null;	 	
	// SPP UUID service
	private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
	private static final String TAG = "bluetooth2";
	private ConnectedThread mConnectedThread;
	
	String sresultado;
	Handler bluetoothIn;
	final int handlerState = 0;             //used to identify handler message
	private StringBuilder recDataString = new StringBuilder();
	

    @Override
    protected void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
        Wentrada=(EditText)findViewById(R.id.Aentrada);
        Wsalida=(EditText)findViewById(R.id.Asalida); 
        
        Miblue = BluetoothAdapter.getDefaultAdapter();
        
             
        if (Miblue == null) 
        {
        	AlertDialog.Builder dialog = new AlertDialog.Builder(this);
			  dialog.setMessage("Sin soporte bluetooth");
			  dialog.setCancelable(false);
			  dialog.setPositiveButton("OK", new DialogInterface.OnClickListener() 
			  	{
					//  @Override
					public void onClick(DialogInterface dialog, int which) { finish();	}				  
			  	});
			  dialog.show(); 
        }     
        
        if (!Miblue.isEnabled()) 
        {
        	  AlertDialog.Builder dialog = new AlertDialog.Builder(this);       	  
			  dialog.setMessage("Activar bluetooth");
			  dialog.setCancelable(false);			  
			  dialog.setPositiveButton("OK", new DialogInterface.OnClickListener() 
			  	{
				 // @Override
				  public void onClick(DialogInterface dialog, int which) {finish();	}
				 		    		   			    	  
		    	});			  
		    	dialog.show(); 
        } 
        
        
        bluetoothIn = new Handler()
        {
            public void handleMessage(android.os.Message msg)
            {
         	
                if (msg.what == handlerState)
                  {          //if message is what we want
                	
                    String readMessage = (String) msg.obj;                                                                // msg.arg1 = bytes from connect thread
                    recDataString.append(readMessage);              //keep appending to string until ~
                    int endOfLineIndex = recDataString.indexOf("END");  // determine the end-of-line

                    if (endOfLineIndex > 0) 
                     {  
                    	// make sure there data before ~
                        String dataInPrint = recDataString.substring(0, endOfLineIndex);    // extract string
                        Wentrada.setText( dataInPrint);

                        recDataString.delete(0, recDataString.length());      //clear all string data
                        // strIncom =" ";
                        dataInPrint = " ";
                     }
                }
            }
        };

        
  /*      
        AlertDialog.Builder dialog0 = new AlertDialog.Builder(this);
        dialog0.setMessage("Programa para conectar android y arduino.\nInterface  XFW-HX711.\nSETA43");
        dialog0.setCancelable(false);
        dialog0.setPositiveButton("OK", new DialogInterface.OnClickListener()
              {

				@Override
				public void onClick(DialogInterface dialog, int which) 
				{
					// TODO Auto-generated method stub
					FunConectar2();	
				}                                           
            });
        
        dialog0.show(); 
    */
        FunConectar2();	   
        
    }
    
    public void  Fsalir(View view) throws IOException
    {
    	btSocket.close();
    	finish();
    }
    
 
    
    public void FunConectar2()
    {
    	pairedDevices = Miblue.getBondedDevices(); 	
        ArrayList <String> list = new ArrayList<String>();
        
        for(BluetoothDevice Miblue : pairedDevices)
        	{
         		list.add(Miblue.getName() + "\n" + Miblue.getAddress());
        	}
          
        
        final CharSequence[] RedesBlue = list.toArray(new CharSequence[list.size()]);
        
    	AlertDialog.Builder builder = new AlertDialog.Builder(this);  
    	builder.setTitle("Selecciona adaptador");  
    	builder.setItems(RedesBlue, new DialogInterface.OnClickListener() 
    		{      
    		public void onClick(DialogInterface dialog, int item) 
    			{          
    				Toast.makeText(getApplicationContext(), RedesBlue[item], Toast.LENGTH_SHORT).show();			
    			    String info = (String) RedesBlue[item];
                    String address = info.substring(info.length() - 17);
                    BluetoothDevice device = Miblue.getRemoteDevice(address);                                     
                    try
                    	{
                        	btSocket = createBluetoothSocket(device);                        	
                    	} 
                    catch (IOException e1)
                    	{ Wentrada.setText("Error_Conectado Sock");	}                                     
                    Miblue.cancelDiscovery();                    
                    Log.d(TAG, "...Conectando...");
                    Log.d(TAG, "...Create Socket...");
                    
                    try 
                    	{
                    		btSocket.connect();
                    		Log.d(TAG, "....Conexion ok...");
                    		Wentrada.setText("ok->" + address);
                    	} 
                    catch (IOException e) 
                    	{
                    		try 
                    			{ 
                    			  Wentrada.setText("Error>" + address);
                    			  btSocket.close();
                    			  Log.d(TAG, "Error>" + address);
                    			} 
                    		catch (IOException e2)
                    			{ errorExit("Fatal Error", "En onResume() ano puedo cerrar socket " + e2.getMessage() + "."); }
                    	}
                                     
                 
                    mConnectedThread = new ConnectedThread(btSocket);
                    mConnectedThread.start();    				    				
    			}  
    	});  
    	AlertDialog alert = builder.create();  
    	alert.show();
    }
    
    private BluetoothSocket createBluetoothSocket(BluetoothDevice device) throws IOException 
    {
        if(Build.VERSION.SDK_INT >= 10)
        {
            try 
            	{
                 final Method  m = device.getClass().getMethod("createInsecureRfcommSocketToServiceRecord", new Class[] { UUID.class });
                 return (BluetoothSocket) m.invoke(device, MY_UUID);
            	}
            catch (Exception e)
            	{    Log.e(TAG, "Could not create Insecure RFComm Connection",e);	}
        }
        return  device.createRfcommSocketToServiceRecord(MY_UUID);
    }
           
    
    private void errorExit(String title, String message)
 	{
	    Toast.makeText(getBaseContext(), title + " - " + message, Toast.LENGTH_LONG).show();
	    finish();
	}
 	 
    private class ConnectedThread extends Thread 
 	{
        private final InputStream mmInStream;
        private final OutputStream mmOutStream;
 
        public ConnectedThread(BluetoothSocket socket) 
         {
            InputStream tmpIn = null;
            OutputStream tmpOut = null;
            try 
            	{
                tmpIn = socket.getInputStream();
                tmpOut = socket.getOutputStream();
                } 
            catch (IOException e) { } 
            mmInStream = tmpIn;
            mmOutStream = tmpOut;
         }
 

 
        public void run()
        {
            byte[] buffer = new byte[256];
            int bytes;

            // Keep looping to listen for received messages
            while (true) {
                try {
                    bytes = mmInStream.read(buffer);         //read bytes from input buffer
                    String readMessage = new String(buffer, 0, bytes);
                    // Send the obtained bytes to the UI Activity via handler
                    bluetoothIn.obtainMessage(handlerState, bytes, -1, readMessage).sendToTarget();
                } catch (IOException e) {  break;  }
            }
        }
        

        
        
        /* Call this from the main activity to send data to the remote device */
        public void write(String message) 
        {
            Log.d(TAG, "...Data to send: " + message + "...");
            byte[] msgBuffer = message.getBytes();
            try 
            	{  mmOutStream.write(msgBuffer);  }
            catch (IOException e)
            	{  Log.d(TAG, "...Error data send: " + e.getMessage() + "...");  }
        }
        
    }
     
    
}

